Index: /BAORadio/libindi/libindi/drivers/telescope/celestrongps.cpp
===================================================================
--- /BAORadio/libindi/libindi/drivers/telescope/celestrongps.cpp	(revision 641)
+++ /BAORadio/libindi/libindi/drivers/telescope/celestrongps.cpp	(revision 642)
@@ -525,7 +525,8 @@
 
 	 if (IUUpdateSwitch(&MovementNSSP, states, names, n) < 0)
-		return;
-
-	current_move = getOnSwitch(&SlewModeSP);
+        IDLog("fixme!!! - IUUpdateSwitch MovementNSSP\n");
+	//	return;
+
+	current_move = getOnSwitch(&MovementNSSP);
 
 	// Previosuly active switch clicked again, so let's stop.
@@ -569,7 +570,8 @@
 
 	 if (IUUpdateSwitch(&MovementWESP, states, names, n) < 0)
-		return;
-
-	current_move = getOnSwitch(&SlewModeSP);
+        IDLog("fixme!!! - IUUpdateSwitch MovementWESP\n");
+		//return;
+
+	current_move = getOnSwitch(&MovementWESP);
 
 	// Previosuly active switch clicked again, so let's stop.
Index: /BAORadio/libindi/libindi/drivers/telescope/celestronprotocol.c
===================================================================
--- /BAORadio/libindi/libindi/drivers/telescope/celestronprotocol.c	(revision 641)
+++ /BAORadio/libindi/libindi/drivers/telescope/celestronprotocol.c	(revision 642)
@@ -286,10 +286,10 @@
     {
       slewCmd[2] = 0x10; 
-      slewCmd[3] = 0x24;
+      slewCmd[3] = 0x25;
     }
   else if(direction == SOUTH)
     {
       slewCmd[2] = 0x11; 
-      slewCmd[3] = 0x24;
+      slewCmd[3] = 0x25;
     }
   else if(direction == WEST)
Index: /BAORadio/libindi/libindi/drivers/telescope/lx200driver.c
===================================================================
--- /BAORadio/libindi/libindi/drivers/telescope/lx200driver.c	(revision 641)
+++ /BAORadio/libindi/libindi/drivers/telescope/lx200driver.c	(revision 642)
@@ -88,5 +88,5 @@
 int setCommandXYZ(int fd, int x, int y, int z, const char *cmd);
 /* Common routine for Set commands */
-int setStandardProcedure(int fd, char * writeData);
+int setStandardProcedure(int fd, const char * writeData);
 /* Set Slew Mode */
 int setSlewMode(int fd, int slewMode);
@@ -220,6 +220,10 @@
   /*if ( (read_ret = portRead(temp_string, -1, LX200_TIMEOUT)) < 1)
      return read_ret;*/
-  tty_read_section(fd, temp_string, '#', LX200_TIMEOUT, &nbytes_read);
- 
+
+  error_type = tty_read_section(fd, temp_string, '#', LX200_TIMEOUT, &nbytes_read);
+  tcflush(fd, TCIFLUSH);
+  if (error_type != TTY_OK)
+    return error_type;
+
   temp_string[nbytes_read - 1] = '\0';
   
@@ -251,5 +255,8 @@
    return error_type;
   
-  tty_read_section(fd, temp_string, '#', LX200_TIMEOUT, &nbytes_read);
+  error_type = tty_read_section(fd, temp_string, '#', LX200_TIMEOUT, &nbytes_read);
+  tcflush(fd, TCIFLUSH);
+  if (error_type != TTY_OK)
+    return error_type;
  
   temp_string[nbytes_read - 1] = '\0';
@@ -685,5 +692,5 @@
 **********************************************************************/
 
-int setStandardProcedure(int fd, char * data)
+int setStandardProcedure(int fd, const char * data)
 {
  char bool_return[2];
Index: /BAORadio/libindi/libindi/drivers/telescope/lx200driver.h
===================================================================
--- /BAORadio/libindi/libindi/drivers/telescope/lx200driver.h	(revision 641)
+++ /BAORadio/libindi/libindi/drivers/telescope/lx200driver.h	(revision 642)
@@ -174,5 +174,5 @@
 int setCommandXYZ(int fd, int x, int y, int z, const char *cmd);
 /* Common routine for Set commands */
-int setStandardProcedure(int fd, char * writeData);
+int setStandardProcedure(int fd, const char * writeData);
 /* Set Slew Mode */
 int setSlewMode(int fd, int slewMode);
Index: /BAORadio/libindi/libindi/drivers/telescope/lx200generic.cpp
===================================================================
--- /BAORadio/libindi/libindi/drivers/telescope/lx200generic.cpp	(revision 641)
+++ /BAORadio/libindi/libindi/drivers/telescope/lx200generic.cpp	(revision 642)
@@ -33,4 +33,5 @@
 #include "lx200ap.h"
 #include "lx200classic.h"
+#include "lx200fs2.h"
 
 #include <config.h>
@@ -331,4 +332,5 @@
   changeLX200ClassicDeviceName(newName);
   changeLX200GPSDeviceName(newName);
+  changeLX200FS2DeviceName(newName);
 }
 
@@ -464,4 +466,25 @@
 
    MaxReticleFlashRate = 9;
+ }
+ else if (strstr(me, "indi_lx200fs2"))
+ {
+   fprintf(stderr , "initilizaing from fs2 device...\n");
+  
+   // 2. device = sub_class
+   telescope = new LX200Fs2();
+	 
+   if (envDev != NULL)
+   {
+	   // 1. change device name
+	   changeAllDeviceNames(envDev);
+	   telescope->setCurrentDeviceName(envDev);
+   }
+   else
+   {
+	  // 1. change device name
+	  changeAllDeviceNames("LX200 FS2");
+      telescope->setCurrentDeviceName("LX200 FS2");
+   }
+   
  }
  // be nice and give them a generic device
Index: /BAORadio/libindi/libindi/drivers/telescope/lx200generic.h
===================================================================
--- /BAORadio/libindi/libindi/drivers/telescope/lx200generic.h	(revision 641)
+++ /BAORadio/libindi/libindi/drivers/telescope/lx200generic.h	(revision 642)
@@ -45,9 +45,9 @@
  int checkPower(ISwitchVectorProperty *sp);
  int checkPower(ITextVectorProperty *tp);
- void handleError(ISwitchVectorProperty *svp, int err, const char *msg);
- void handleError(INumberVectorProperty *nvp, int err, const char *msg);
- void handleError(ITextVectorProperty *tvp, int err, const char *msg);
+ virtual void handleError(ISwitchVectorProperty *svp, int err, const char *msg);
+ virtual void handleError(INumberVectorProperty *nvp, int err, const char *msg);
+ virtual void handleError(ITextVectorProperty *tvp, int err, const char *msg);
  bool isTelescopeOn(void);
- void connectTelescope();
+ virtual void connectTelescope();
  void slewError(int slewCode);
  void getAlignment();
@@ -80,5 +80,4 @@
   int    currentSet;
   int    lastSet;
-  
 
 };
Index: /BAORadio/libindi/libindi/drivers/telescope/synscanmount.cpp
===================================================================
--- /BAORadio/libindi/libindi/drivers/telescope/synscanmount.cpp	(revision 641)
+++ /BAORadio/libindi/libindi/drivers/telescope/synscanmount.cpp	(revision 642)
@@ -2,21 +2,19 @@
   Copyright(c) 2010 Gerry Rozema. All rights reserved.
 
-  This program is free software; you can redistribute it and/or modify it
-  under the terms of the GNU General Public License as published by the Free
-  Software Foundation; either version 2 of the License, or (at your option)
-  any later version.
-
-  This program is distributed in the hope that it will be useful, but WITHOUT
-  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
-  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
-  more details.
-
-  You should have received a copy of the GNU General Public License along with
-  this program; if not, write to the Free Software Foundation, Inc., 59
-  Temple Place - Suite 330, Boston, MA  02111-1307, USA.
-
-  The full GNU General Public License is included in this distribution in the
-  file called LICENSE.
+ This library is free software; you can redistribute it and/or
+ modify it under the terms of the GNU Library General Public
+ License version 2 as published by the Free Software Foundation.
+
+ This library is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ Library General Public License for more details.
+
+ You should have received a copy of the GNU Library General Public License
+ along with this library; see the file COPYING.LIB.  If not, write to
+ the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ Boston, MA 02110-1301, USA.
 *******************************************************************************/
+
 #include "synscanmount.h"
 #include "libs/indicom.h"
@@ -39,4 +37,5 @@
 void ISPoll(void *p);
 
+#define isDebug() true
 
 void ISInit()
@@ -110,5 +109,5 @@
 bool SynscanMount::initProperties()
 {
-    if (isDebug())
+    //if (isDebug())
         IDLog("Synscan::init_properties\n");
 
@@ -120,5 +119,5 @@
 void SynscanMount::ISGetProperties (const char *dev)
 {
-    if (isDebug())
+    //if (isDebug())
         IDLog("Enter SynscanMount::ISGetProperties %s\n",dev);
 
@@ -139,5 +138,5 @@
     int n1,n2;
 
-    //IDLog("Read Status\n");
+    //IDLog("SynScan Read Status\n");
     //tty_write(PortFD,(unsigned char *)"Ka",2, &bytesWritten);  //  test for an echo
 
@@ -147,5 +146,5 @@
     {
         //  this is not a correct echo
-        if (isDebug())
+        //if (isDebug())
             IDLog("ReadStatus Echo Fail\n");
         IDMessage(deviceName(),"Mount Not Responding");
@@ -192,5 +191,6 @@
     tty_write(PortFD,"e",1, &bytesWritten);
     numread=tty_read(PortFD,str,18,1, &bytesRead);
-    if (numread!=18)
+    if (bytesRead!=18)
+	//if(str[17] != '#')
     {
         IDLog("read status bytes didn't get a full read\n");
@@ -230,5 +230,5 @@
     TrackState=SCOPE_SLEWING;
     numread=tty_read(PortFD,str,1,60, &bytesRead);
-    if (numread!=1||str[0]!='#')
+    if (bytesRead!=1||str[0]!='#')
     {
         if (isDebug())
@@ -258,5 +258,5 @@
     tty_write(PortFD,"T0",2, &bytesWritten);
     numread=tty_read(PortFD,str,1,60, &bytesRead);
-    if (numread!=1||str[0]!='#')
+    if (bytesRead!=1||str[0]!='#')
     {
         if (isDebug())
@@ -268,5 +268,5 @@
     tty_write(PortFD,"B0000,4000",10, &bytesWritten);
     numread=tty_read(PortFD,str,1,60, &bytesRead);
-    if (numread!=1||str[0]!='#')
+    if (bytesRead!=1||str[0]!='#')
     {
         if (isDebug())
Index: /BAORadio/libindi/libindi/drivers/telescope/synscanmount.h
===================================================================
--- /BAORadio/libindi/libindi/drivers/telescope/synscanmount.h	(revision 641)
+++ /BAORadio/libindi/libindi/drivers/telescope/synscanmount.h	(revision 642)
@@ -2,20 +2,17 @@
   Copyright(c) 2010 Gerry Rozema. All rights reserved.
 
-  This program is free software; you can redistribute it and/or modify it
-  under the terms of the GNU General Public License as published by the Free
-  Software Foundation; either version 2 of the License, or (at your option)
-  any later version.
+ This library is free software; you can redistribute it and/or
+ modify it under the terms of the GNU Library General Public
+ License version 2 as published by the Free Software Foundation.
 
-  This program is distributed in the hope that it will be useful, but WITHOUT
-  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
-  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
-  more details.
+ This library is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ Library General Public License for more details.
 
-  You should have received a copy of the GNU General Public License along with
-  this program; if not, write to the Free Software Foundation, Inc., 59
-  Temple Place - Suite 330, Boston, MA  02111-1307, USA.
-
-  The full GNU General Public License is included in this distribution in the
-  file called LICENSE.
+ You should have received a copy of the GNU Library General Public License
+ along with this library; see the file COPYING.LIB.  If not, write to
+ the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ Boston, MA 02110-1301, USA.
 *******************************************************************************/
 
@@ -39,4 +36,5 @@
         const char *getDefaultName();
 
+        //virtual bool Connect() {return true;}
         bool ReadScopeStatus();
         bool Goto(double,double);
Index: /BAORadio/libindi/libindi/drivers/telescope/telescope_simulator.cpp
===================================================================
--- /BAORadio/libindi/libindi/drivers/telescope/telescope_simulator.cpp	(revision 641)
+++ /BAORadio/libindi/libindi/drivers/telescope/telescope_simulator.cpp	(revision 642)
@@ -13,7 +13,22 @@
 std::auto_ptr<ScopeSim> telescope_sim(0);
 
-#define	SLEWRATE	1				/* slew rate, degrees/s */
+#define	GOTO_RATE	2				/* slew rate, degrees/s */
+#define	SLEW_RATE	0.5				/* slew rate, degrees/s */
+#define FINE_SLEW_RATE  0.1                             /* slew rate, degrees/s */
+#define SID_RATE	0.004178			/* sidereal rate, degrees/s */
+
+#define GOTO_LIMIT      5                               /* Move at GOTO_RATE until distance from target is GOTO_LIMIT degrees */
+#define SLEW_LIMIT      2                               /* Move at SLEW_LIMIT until distance from target is SLEW_LIMIT degrees */
+#define FINE_SLEW_LIMIT 0.5                             /* Move at FINE_SLEW_RATE until distance from target is FINE_SLEW_LIMIT degrees */
+
 #define	POLLMS		250				/* poll period, ms */
-#define SIDRATE		0.004178			/* sidereal rate, degrees/s */
+
+#define RA_AXIS         0
+#define DEC_AXIS        1
+#define GUIDE_NORTH     0
+#define GUIDE_SOUTH     1
+#define GUIDE_WEST      0
+#define GUIDE_EAST      1
+
 
 
@@ -80,4 +95,15 @@
     currentDEC=15;
     Parked=false;
+
+    GuideNSNP = new INumberVectorProperty;
+    GuideWENP = new INumberVectorProperty;
+    EqPECNV = new INumberVectorProperty;
+    GuideRateNP = new INumberVectorProperty;
+
+    PECErrNSSP = new ISwitchVectorProperty;
+    PECErrWESP = new ISwitchVectorProperty;
+
+    /* initialize random seed: */
+      srand ( time(NULL) );
 }
 
@@ -90,4 +116,104 @@
 {
     return (char *)"Telescope Simulator";
+}
+
+bool ScopeSim::initProperties()
+{
+    /* Make sure to init parent properties first */
+    INDI::Telescope::initProperties();
+
+    /* Property for guider support. How many seconds to guide either northward or southward? */
+    IUFillNumber(&GuideNSN[GUIDE_NORTH], "TIMED_GUIDE_N", "North (sec)", "%g", 0, 10, 0.001, 0);
+    IUFillNumber(&GuideNSN[GUIDE_SOUTH], "TIMED_GUIDE_S", "South (sec)", "%g", 0, 10, 0.001, 0);
+    IUFillNumberVector(GuideNSNP, GuideNSN, 2, deviceName(), "TELESCOPE_TIMED_GUIDE_NS", "Guide North/South", MOTION_TAB, IP_RW, 0, IPS_IDLE);
+
+    /* Property for guider support. How many seconds to guide either westward or eastward? */
+    IUFillNumber(&GuideWEN[GUIDE_WEST], "TIMED_GUIDE_W", "West (sec)", "%g", 0, 10, 0.001, 0);
+    IUFillNumber(&GuideWEN[GUIDE_EAST], "TIMED_GUIDE_E", "East (sec)", "%g", 0, 10, 0.001, 0);
+    IUFillNumberVector(GuideWENP, GuideWEN, 2, deviceName(), "TELESCOPE_TIMED_GUIDE_WE", "Guide West/East", MOTION_TAB, IP_RW, 0, IPS_IDLE);
+
+    /* Simulated periodic error in RA, DEC */
+    IUFillNumber(&EqPECN[RA_AXIS],"RA_PEC","RA (hh:mm:ss)","%010.6m",0,24,0,15.);
+    IUFillNumber(&EqPECN[DEC_AXIS],"DEC_PEC","DEC (dd:mm:ss)","%010.6m",-90,90,0,15.);
+    IUFillNumberVector(EqPECNV,EqPECN,2,deviceName(),"EQUATORIAL_PEC","Periodic Error",MOTION_TAB,IP_RO,60,IPS_IDLE);
+
+    /* Enable client to manually add periodic error northward or southward for simulation purposes */
+    IUFillSwitch(&PECErrNSS[MOTION_NORTH], "PEC_N", "North", ISS_OFF);
+    IUFillSwitch(&PECErrNSS[MOTION_SOUTH], "PEC_S", "South", ISS_OFF);
+    IUFillSwitchVector(PECErrNSSP, PECErrNSS, 2, deviceName(),"PEC_NS", "PE N/S", MOTION_TAB, IP_RW, ISR_1OFMANY, 60, IPS_IDLE);
+
+    /* Enable client to manually add periodic error westward or easthward for simulation purposes */
+    IUFillSwitch(&PECErrWES[MOTION_WEST], "PEC_W", "West", ISS_OFF);
+    IUFillSwitch(&PECErrWES[MOTION_EAST], "PEC_E", "East", ISS_OFF);
+    IUFillSwitchVector(PECErrWESP, PECErrWES, 2, deviceName(),"PEC_WE", "PE W/E", MOTION_TAB, IP_RW, ISR_1OFMANY, 60, IPS_IDLE);
+
+    /* How fast do we guide compared to sideral rate */
+    IUFillNumber(&GuideRateN[RA_AXIS], "GUIDE_RATE_WE", "W/E Rate", "%g", 0, 1, 0.1, 0.3);
+    IUFillNumber(&GuideRateN[DEC_AXIS], "GUIDE_RATE_NS", "N/S Rate", "%g", 0, 1, 0.1, 0.3);
+    IUFillNumberVector(GuideRateNP, GuideRateN, 2, deviceName(), "GUIDE_RATE", "Guiding Rate", MOTION_TAB, IP_RW, 0, IPS_IDLE);
+
+    /* Add debug controls so we may debug driver if necessary */
+    addDebugControl();
+
+    return true;
+}
+
+void ScopeSim::ISGetProperties (const char *dev)
+{
+    /* First we let our parent populate */
+    INDI::Telescope::ISGetProperties(dev);
+
+    if(isConnected())
+    {
+        defineNumber(GuideNSNP);
+        defineNumber(GuideWENP);
+        defineNumber(GuideRateNP);
+        defineNumber(EqPECNV);
+        defineSwitch(PECErrNSSP);
+        defineSwitch(PECErrWESP);
+    }
+
+    return;
+}
+
+bool ScopeSim::updateProperties()
+{
+    INDI::Telescope::updateProperties();
+
+    if (isConnected())
+    {
+        defineNumber(GuideNSNP);
+        defineNumber(GuideWENP);
+        defineNumber(GuideRateNP);
+        defineNumber(EqPECNV);
+        defineSwitch(PECErrNSSP);
+        defineSwitch(PECErrWESP);
+
+    }
+    else
+    {
+        deleteProperty(GuideNSNP->name);
+        deleteProperty(GuideWENP->name);
+        deleteProperty(EqPECNV->name);
+        deleteProperty(PECErrNSSP->name);
+        deleteProperty(PECErrNSSP->name);
+        deleteProperty(GuideRateNP->name);
+    }
+
+    return true;
+}
+
+bool ScopeSim::Connect()
+{
+    bool rc=false;
+
+    if(isConnected()) return true;
+
+    rc=Connect(PortT[0].text);
+
+    if(rc)
+        SetTimer(POLLMS);
+
+    return rc;
 }
 
@@ -106,6 +232,8 @@
     static struct timeval ltv;
     struct timeval tv;
-    double dt, da, dx;
-    int nlocked;
+    double dt=0, da_ra=0, da_dec=0, dx=0, dy=0, ra_guide_dt=0, dec_guide_dt=0;
+    static double last_dx=0, last_dy=0;
+    int nlocked, ns_guide_dir=-1, we_guide_dir=-1;
+    char RA_DISP[64], DEC_DISP[64], RA_GUIDE[64], DEC_GUIDE[64], RA_PEC[64], DEC_PEC[64], RA_TARGET[64], DEC_TARGET[64];
 
 
@@ -118,9 +246,53 @@
     dt = tv.tv_sec - ltv.tv_sec + (tv.tv_usec - ltv.tv_usec)/1e6;
     ltv = tv;
-    da = SLEWRATE*dt;
+
+    if ( fabs(targetRA - currentRA)*15. >= GOTO_LIMIT )
+        da_ra = GOTO_RATE *dt;
+    else if ( fabs(targetRA - currentRA)*15. >= SLEW_LIMIT )
+        da_ra = SLEW_RATE *dt;
+    else
+        da_ra = FINE_SLEW_RATE *dt;
+
+    if ( fabs(targetDEC - currentDEC) >= GOTO_LIMIT )
+        da_dec = GOTO_RATE *dt;
+    else if ( fabs(targetDEC - currentDEC) >= SLEW_LIMIT )
+        da_dec = SLEW_RATE *dt;
+    else
+        da_dec = FINE_SLEW_RATE *dt;
+
+    switch (MovementNSSP->s)
+    {
+       case IPS_BUSY:
+        if (MovementNSS[MOTION_NORTH].s == ISS_ON)
+            currentDEC += da_dec;
+        else if (MovementNSS[MOTION_SOUTH].s == ISS_ON)
+            currentDEC -= da_dec;
+
+        NewRaDec(currentRA, currentDEC);
+        return true;
+        break;
+    }
+
+    switch (MovementWESP->s)
+    {
+        case IPS_BUSY:
+
+        if (MovementWES[MOTION_WEST].s == ISS_ON)
+            currentRA += da_ra/15.;
+        else if (MovementWES[MOTION_EAST].s == ISS_ON)
+            currentRA -= da_ra/15.;
+
+        NewRaDec(currentRA, currentDEC);
+        return true;
+        break;
+
+    }
 
     /* Process per current state. We check the state of EQUATORIAL_EOD_COORDS_REQUEST and act acoordingly */
     switch (TrackState)
     {
+    case SCOPE_IDLE:
+        EqNV->s = IPS_IDLE;
+        break;
     case SCOPE_SLEWING:
     case SCOPE_PARKING:
@@ -130,5 +302,5 @@
         dx = targetRA - currentRA;
 
-        if (fabs(dx) <= da)
+        if (fabs(dx)*15. <= da_ra)
         {
             currentRA = targetRA;
@@ -136,29 +308,36 @@
         }
         else if (dx > 0)
-            currentRA += da/15.;
+            currentRA += da_ra/15.;
         else
-            currentRA -= da/15.;
-
-
-        dx = targetDEC - currentDEC;
-        if (fabs(dx) <= da)
+            currentRA -= da_ra/15.;
+
+
+        dy = targetDEC - currentDEC;
+        if (fabs(dy) <= da_dec)
         {
             currentDEC = targetDEC;
             nlocked++;
         }
-        else if (dx > 0)
-          currentDEC += da;
+        else if (dy > 0)
+          currentDEC += da_dec;
         else
-          currentDEC -= da;
+          currentDEC -= da_dec;
+
+        EqNV->s = IPS_BUSY;
 
         if (nlocked == 2)
         {
-            //eqNP.s = IPS_OK;
-            //eqNPR.s = IPS_OK;
-            //IDSetNumber(&eqNP, NULL);
-            //IDSetNumber(&eqNPR, "Now tracking");
             if (TrackState == SCOPE_SLEWING)
             {
+
+                // Initially no PEC in both axis.
+                EqPECN[0].value = currentRA;
+                EqPECN[1].value = currentDEC;
+
+                IDSetNumber(EqPECNV, NULL);
+
                 TrackState = SCOPE_TRACKING;
+
+                EqNV->s = IPS_OK;
                 IDMessage(deviceName(), "Telescope slew is complete. Tracking...");
             }
@@ -166,9 +345,8 @@
             {
                 TrackState = SCOPE_PARKED;
+                EqNV->s = IPS_IDLE;
                 IDMessage(deviceName(), "Telescope parked successfully.");
             }
         }
-        //else
-          //  IDSetNumber(&eqNP, NULL);
 
         break;
@@ -176,6 +354,115 @@
     case SCOPE_TRACKING:
         /* tracking */
-        /* RA moves at sidereal, Dec stands still */
-         currentRA += (SIDRATE*dt/15.);
+
+        if (GuideNSN[GUIDE_NORTH].value > 0)
+        {
+            if (isDebug())
+                IDLog("  ****** Commanded to GUIDE NORTH for %g ms *****\n", GuideNSN[GUIDE_NORTH].value*1000);
+            ns_guide_dir = GUIDE_NORTH;
+        }
+        else if (GuideNSN[GUIDE_SOUTH].value > 0)
+        {
+            if (isDebug())
+                IDLog("  ****** Commanded to GUIDE SOUTH for %g ms *****\n", GuideNSN[GUIDE_SOUTH].value*1000);
+            ns_guide_dir = GUIDE_SOUTH;
+        }
+
+        // WE Guide Selection
+        if (GuideWEN[GUIDE_WEST].value > 0)
+        {
+            we_guide_dir = GUIDE_WEST;
+            if (isDebug())
+            IDLog("  ****** Commanded to GUIDE WEST for %g ms ****** \n", GuideWEN[GUIDE_WEST].value*1000);
+        }
+        else if (GuideWEN[GUIDE_EAST].value > 0)
+        {
+            we_guide_dir = GUIDE_EAST;
+            if (isDebug())
+               IDLog(" ****** Commanded to GUIDE EAST for %g ms  ****** \n", GuideWEN[GUIDE_EAST].value*1000);
+        }
+
+        if (ns_guide_dir != -1)
+        {
+
+            dec_guide_dt =  SID_RATE * GuideRateN[DEC_AXIS].value * GuideNSN[ns_guide_dir].value * (ns_guide_dir==GUIDE_NORTH ? 1 : -1);
+
+            // If time remaining is more that dt, then decrement and
+          if (GuideNSN[ns_guide_dir].value >= dt)
+              GuideNSN[ns_guide_dir].value -= dt;
+          else              
+              GuideNSN[ns_guide_dir].value = 0;
+
+          EqPECN[DEC_AXIS].value += dec_guide_dt;
+
+            if (GuideNSN[ns_guide_dir].value <= 0)
+            {
+                GuideNSN[GUIDE_NORTH].value = GuideNSN[GUIDE_SOUTH].value = 0;
+                GuideNSNP->s = IPS_OK;
+                IDSetNumber(GuideNSNP, NULL);
+            }
+            else
+                IDSetNumber(GuideNSNP, NULL);
+          }
+
+        if (we_guide_dir != -1)
+        {
+
+            ra_guide_dt = SID_RATE/15.0 * GuideRateN[RA_AXIS].value * GuideWEN[we_guide_dir].value* (we_guide_dir==GUIDE_WEST ? -1 : 1);
+
+          if (GuideWEN[we_guide_dir].value >= dt)
+                GuideWEN[we_guide_dir].value -= dt;
+          else
+                GuideWEN[we_guide_dir].value = 0;
+
+          EqPECN[RA_AXIS].value += ra_guide_dt;
+
+            if (GuideWEN[we_guide_dir].value <= 0)
+            {
+                GuideWEN[GUIDE_WEST].value = GuideWEN[GUIDE_EAST].value = 0;
+                GuideWENP->s = IPS_OK;
+                IDSetNumber(GuideWENP, NULL);
+            }
+            else
+                IDSetNumber(GuideWENP, NULL);
+          }
+
+
+        //Mention the followng:
+        // Current RA displacemet and direction
+        // Current DEC displacement and direction
+        // Amount of RA GUIDING correction and direction
+        // Amount of DEC GUIDING correction and direction
+
+        dx = EqPECN[RA_AXIS].value - targetRA;
+        dy = EqPECN[DEC_AXIS].value - targetDEC;
+        fs_sexa(RA_DISP, fabs(dx), 2, 3600 );
+        fs_sexa(DEC_DISP, fabs(dy), 2, 3600 );
+
+        fs_sexa(RA_GUIDE, fabs(ra_guide_dt), 2, 3600 );
+        fs_sexa(DEC_GUIDE, fabs(dec_guide_dt), 2, 3600 );
+
+        fs_sexa(RA_PEC, EqPECN[RA_AXIS].value, 2, 3600);
+        fs_sexa(DEC_PEC, EqPECN[DEC_AXIS].value, 2, 3600);
+
+        fs_sexa(RA_TARGET, targetRA, 2, 3600);
+        fs_sexa(DEC_TARGET, targetDEC, 2, 3600);
+
+
+        if (isDebug() && (dx!=last_dx || dy!=last_dy || ra_guide_dt || dec_guide_dt))
+        {
+            last_dx=dx;
+            last_dy=dy;
+            IDLog("#########################################\n");
+            IDLog("dt is %g\n", dt);
+            IDLog("RA Displacement (%c%s) %s -- %s of target RA %s\n", dx >= 0 ? '+' : '-', RA_DISP, RA_PEC,  (EqPECN[RA_AXIS].value - targetRA) > 0 ? "East" : "West", RA_TARGET);
+            IDLog("DEC Displacement (%c%s) %s -- %s of target RA %s\n", dy >= 0 ? '+' : '-', DEC_DISP, DEC_PEC, (EqPECN[DEC_AXIS].value - targetDEC) > 0 ? "North" : "South", DEC_TARGET);
+            IDLog("RA Guide Correction (%g) %s -- Direction %s\n", ra_guide_dt, RA_GUIDE, ra_guide_dt > 0 ? "East" : "West");
+            IDLog("DEC Guide Correction (%g) %s -- Direction %s\n", dec_guide_dt, DEC_GUIDE, dec_guide_dt > 0 ? "North" : "South");
+            IDLog("#########################################\n");
+        }
+
+        if (ns_guide_dir != -1 || we_guide_dir != -1)
+            IDSetNumber(EqPECNV, NULL);
+
          break;
 
@@ -200,4 +487,8 @@
     Parked=false;
     TrackState = SCOPE_SLEWING;
+
+    EqReqNV->s = IPS_BUSY;
+    EqNV->s    = IPS_BUSY;
+
     IDMessage(deviceName(), "Slewing to RA: %s - DEC: %s", RAStr, DecStr);
     return true;
@@ -214,28 +505,192 @@
 }
 
-bool ScopeSim::Connect()
-{
-    //  Parent class is wanting a connection
-    //IDLog("INDI::Telescope calling connect with %s\n",PortT[0].text);
-    bool rc=false;
-
-    if(isConnected()) return true;
-
-    //IDLog("Calling Connect\n");
-
-    rc=Connect(PortT[0].text);
-
-    if(rc)
-        SetTimer(POLLMS);
-    return rc;
-}
-
-
-
-/* update the "mount" over time */
-void mountSim (void *p)
-{
-
-}
-
-
+bool ScopeSim::ISNewNumber (const char *dev, const char *name, double values[], char *names[], int n)
+{
+    //  first check if it's for our device
+
+    if(strcmp(dev,deviceName())==0)
+    {
+        //  This is for our device
+        //  Now lets see if it's something we process here
+         if(strcmp(name,"TELESCOPE_TIMED_GUIDE_NS")==0)
+         {
+
+             // Unless we're in track mode, we don't obey guide commands.
+             if (TrackState != SCOPE_TRACKING)
+             {
+                 GuideNSNP->s = IPS_IDLE;
+                 IDSetNumber(GuideNSNP, NULL);
+                 return true;
+             }
+
+             IUUpdateNumber(GuideNSNP, values, names, n);
+
+           return true;
+         }
+
+         if(strcmp(name,"TELESCOPE_TIMED_GUIDE_WE")==0)
+         {
+             // Unless we're in track mode, we don't obey guide commands.
+             if (TrackState != SCOPE_TRACKING)
+             {
+                 GuideWENP->s = IPS_IDLE;
+                 IDSetNumber(GuideWENP, NULL);
+                 return true;
+             }
+
+             IUUpdateNumber(GuideWENP, values, names, n);
+
+           return true;
+         }
+
+         if(strcmp(name,"GUIDE_RATE")==0)
+         {
+             IUUpdateNumber(GuideRateNP, values, names, n);
+             GuideRateNP->s = IPS_OK;
+             IDSetNumber(GuideRateNP, NULL);
+             return true;
+         }
+
+    }
+
+    //  if we didn't process it, continue up the chain, let somebody else
+    //  give it a shot
+    return INDI::Telescope::ISNewNumber(dev,name,values,names,n);
+}
+
+bool ScopeSim::ISNewSwitch (const char *dev, const char *name, ISState *states, char *names[], int n)
+{
+    //IDLog("Enter IsNewSwitch for %s\n",name);
+    //for(int x=0; x<n; x++) {
+    //    IDLog("Switch %s %d\n",names[x],states[x]);
+    //}
+
+    if(strcmp(dev,deviceName())==0)
+    {
+        if(strcmp(name,"PEC_NS")==0)
+        {
+            IUUpdateSwitch(PECErrNSSP,states,names,n);
+
+            PECErrNSSP->s = IPS_OK;
+
+            if (PECErrNSS[MOTION_NORTH].s == ISS_ON)
+            {
+                EqPECN[DEC_AXIS].value += SID_RATE * GuideRateN[DEC_AXIS].value;
+                if (isDebug())
+                    IDLog("$$$$$ Simulating PE in NORTH direction for value of %g $$$$$\n", SID_RATE);
+            }
+            else
+            {
+                EqPECN[DEC_AXIS].value -= SID_RATE * GuideRateN[DEC_AXIS].value;
+                if (isDebug())
+                    IDLog("$$$$$ Simulating PE in SOUTH direction for value of %g $$$$$\n", SID_RATE);
+            }
+
+            IUResetSwitch(PECErrNSSP);
+            IDSetSwitch(PECErrNSSP, NULL);
+            IDSetNumber(EqPECNV, NULL);
+
+            return true;
+
+        }
+
+        if(strcmp(name,"PEC_WE")==0)
+        {
+            IUUpdateSwitch(PECErrWESP,states,names,n);
+
+            PECErrWESP->s = IPS_OK;
+
+            if (PECErrWES[MOTION_WEST].s == ISS_ON)
+            {
+                EqPECN[RA_AXIS].value -= SID_RATE/15. * GuideRateN[RA_AXIS].value;
+                if (isDebug())
+                    IDLog("$$$$$ Simulator PE in WEST direction for value of %g $$$$$$\n", SID_RATE);
+            }
+            else
+            {
+                EqPECN[RA_AXIS].value += SID_RATE/15. * GuideRateN[RA_AXIS].value;
+                if (isDebug())
+                    IDLog("$$$$$$ Simulator PE in EAST direction for value of %g $$$$$$\n", SID_RATE);
+            }
+
+            IUResetSwitch(PECErrWESP);
+            IDSetSwitch(PECErrWESP, NULL);
+            IDSetNumber(EqPECNV, NULL);
+
+            return true;
+
+        }
+
+    }
+
+    //  Nobody has claimed this, so, ignore it
+    return INDI::Telescope::ISNewSwitch(dev,name,states,names,n);
+}
+
+
+
+bool ScopeSim::MoveNS(TelescopeMotionNS dir)
+{
+    static int last_motion=-1;
+
+    switch (dir)
+    {
+      case MOTION_NORTH:
+        if (last_motion != MOTION_NORTH)
+            last_motion = MOTION_NORTH;
+        else
+        {
+            IUResetSwitch(MovementNSSP);
+            MovementNSSP->s = IPS_IDLE;
+            IDSetSwitch(MovementNSSP, NULL);
+        }
+        break;
+
+    case MOTION_SOUTH:
+      if (last_motion != MOTION_SOUTH)
+          last_motion = MOTION_SOUTH;
+      else
+      {
+          IUResetSwitch(MovementNSSP);
+          MovementNSSP->s = IPS_IDLE;
+          IDSetSwitch(MovementNSSP, NULL);
+      }
+      break;
+    }
+
+    return true;
+}
+
+bool ScopeSim::MoveWE(TelescopeMotionWE dir)
+{
+    static int last_motion=-1;
+
+    switch (dir)
+    {
+      case MOTION_WEST:
+        if (last_motion != MOTION_WEST)
+            last_motion = MOTION_WEST;
+        else
+        {
+            IUResetSwitch(MovementWESP);
+            MovementWESP->s = IPS_IDLE;
+            IDSetSwitch(MovementWESP, NULL);
+        }
+        break;
+
+    case MOTION_EAST:
+      if (last_motion != MOTION_EAST)
+          last_motion = MOTION_EAST;
+      else
+      {
+          IUResetSwitch(MovementWESP);
+          MovementWESP->s = IPS_IDLE;
+          IDSetSwitch(MovementWESP, NULL);
+      }
+      break;
+    }
+
+    return true;
+
+}
+
